<?php

declare(strict_types=1);

namespace App\Framework\Console;

use App\Framework\Core\AttributeMapper;
use App\Framework\Reflection\WrappedReflectionClass;
use App\Framework\Reflection\WrappedReflectionMethod;

final readonly class ConsoleCommandMapper implements AttributeMapper
{
    public function getAttributeClass(): string
    {
        return ConsoleCommand::class;
    }

    public function map(WrappedReflectionClass|WrappedReflectionMethod $reflectionTarget, object $attributeInstance): ?array
    {
        if (! $reflectionTarget instanceof WrappedReflectionMethod) {
            return null; // ConsoleCommand can only be applied to methods
        }

        return [
            'attribute_data' => [
                'name' => $attributeInstance->name,
                'description' => $attributeInstance->description,
            ],
            'class' => $reflectionTarget->getDeclaringClass(),
            'method' => $reflectionTarget->getName(),
        ];
    }
}
